Index: LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/dustemission_mod.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/dustemission_mod.F90	(revision 5159)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/dustemission_mod.F90	(revision 5160)
@@ -350,8 +350,8 @@
    CALL abort_gcm('adaptdustemission', 'Dust range problem',1)
   ENDIF
-  print *,'FINE DUST BIN: tuning EMISSION factor= ',tuningfactorfine
-  print *,'COA DUST BIN: tuning EMISSION factor= ',tuningfactorcoa
-  print *,'SCO DUST BIN: tuning EMISSION factor= ',tuningfactorsco
-  print *,'ALL DUST BIN: SUM to the emissions (mg/m2/s) = ',basesumemission
+  PRINT *,'FINE DUST BIN: tuning EMISSION factor= ',tuningfactorfine
+  PRINT *,'COA DUST BIN: tuning EMISSION factor= ',tuningfactorcoa
+  PRINT *,'SCO DUST BIN: tuning EMISSION factor= ',tuningfactorsco
+  PRINT *,'ALL DUST BIN: SUM to the emissions (mg/m2/s) = ',basesumemission
   auxr1=9999.
   auxr2=9999.
@@ -418,6 +418,6 @@
 
 
-!print *,'JE'
-!print *,iminacclow,iminacchigh,imincoalow,imincoahigh
+!PRINT *,'JE'
+!PRINT *,iminacclow,iminacchigh,imincoalow,imincoahigh
 
 ! estimate and integrate bins into only accumulation and coarse
@@ -649,5 +649,5 @@
   varname='A'
   CALL read_surface(varname,Aini)
-print *,'beforewritephy',mpi_rank,omp_rank
+PRINT *,'beforewritephy',mpi_rank,omp_rank
   CALL writefield_phy("SOLinit",solini,5)
   CALL writefield_phy("Pinit",Pini,5)
@@ -657,5 +657,5 @@
   CALL writefield_phy("Dinit",Dini,5)
   CALL writefield_phy("Ainit",Aini,5)
-print *,'afterwritephy',mpi_rank,omp_rank
+PRINT *,'afterwritephy',mpi_rank,omp_rank
 
   DO i=1,klon
@@ -667,7 +667,7 @@
     ENDDO
   ENDDO
-!print *,'JEOK1',mpi_rank,omp_rank
+!PRINT *,'JEOK1',mpi_rank,omp_rank
   DO i=1,klon
-    !print *,Pini(i,1),Pini(i,2),Pini(i,3),Pini(i,4),Pini(i,5)
+    !PRINT *,Pini(i,1),Pini(i,2),Pini(i,3),Pini(i,4),Pini(i,5)
     DO nts=1,ntyp
       !IF(xlon(i).ge.longmin.AND.xlon(i).le.longmax.AND. &
@@ -698,7 +698,7 @@
   ENDDO
 
-! print *,'JEOK2',mpi_rank,omp_rank
+! PRINT *,'JEOK2',mpi_rank,omp_rank
 IF ( 1==1 ) THEN
-! print *,'JEOK4',mpi_rank,omp_rank
+! PRINT *,'JEOK4',mpi_rank,omp_rank
    CALL writefield_phy("SOL",sol,5)
    CALL writefield_phy("P"  ,P  ,5)
@@ -712,6 +712,6 @@
    CALL writefield_phy("xlon",xlon,1)
    CALL writefield_phy("xlat",xlat,1)
-!print *,'JEOK5',mpi_rank,omp_rank
-!print *,'JEOK6',mpi_rank,omp_rank
+!PRINT *,'JEOK5',mpi_rank,omp_rank
+!PRINT *,'JEOK6',mpi_rank,omp_rank
 
 END IF
@@ -724,8 +724,8 @@
 ! data format in columns
 ! mmd1  sigma1  p1  mmd2  sigma2  p2 mmd3 ... alpha
-!print *,'JEOK7',mpi_rank,omp_rank
+!PRINT *,'JEOK7',mpi_rank,omp_rank
 !$OMP MASTER
 IF (is_mpi_root .AND. is_omp_root) THEN
-!print *,'JEOK9',mpi_rank,omp_rank
+!PRINT *,'JEOK9',mpi_rank,omp_rank
  fnsolspe='SOILSPEC.data'
   PRINT*,'  o Reading ',fnsolspe(1:40)
@@ -744,5 +744,5 @@
 !$OMP END MASTER
 !$OMP BARRIER
-!print *,'JEOK10',mpi_rank,omp_rank
+!PRINT *,'JEOK10',mpi_rank,omp_rank
   CALL bcast(solspe)
 ! Calcul de la distribution en taille des particules de Dust
@@ -769,5 +769,5 @@
 !if (.TRUE.) THEN
 !c 0: Iversen and White 1982
-       print *,'Using  Iversen and White 1982 Uth'
+       PRINT *,'Using  Iversen and White 1982 Uth'
          DO i=1,ncl
             bb=adust*(sizeclass(i)**xdust)+bdust
@@ -786,5 +786,5 @@
 IF(.TRUE.) THEN
 ! 1: Shao and Lu 2000
-       print *,'Using  Shao and Lu 2000 Uth'
+       PRINT *,'Using  Shao and Lu 2000 Uth'
             an=0.0123
             gam=0.3
@@ -886,5 +886,5 @@
 ! JE20150120<<
   IF (flag_feff == 0) THEN
-    print *,'JE_dbg FORCED deactivated feff'
+    PRINT *,'JE_dbg FORCED deactivated feff'
     DO i=1,klon
       DO k=1,ntyp
@@ -1072,5 +1072,5 @@
             numax=log(d2max/diam(k))
             massfrac(k,nb)=0.5*(erf(numax/exden)-erf(numin/exden))
-            !print *,k,nb,massfrac(k,nb)
+            !PRINT *,k,nb,massfrac(k,nb)
          ENDDO
       ENDDO
@@ -1209,5 +1209,5 @@
                    pdfu=(kref/weilambda)*(wind10ms(kwb)/weilambda)**(kref-1) &
                       *exp(-(wind10ms(kwb)/weilambda)**kref)
-!                   !print *,'JEdbg  U10mMOD weilambda  ',U10mMOD,weilambda
+!                   !PRINT *,'JEdbg  U10mMOD weilambda  ',U10mMOD,weilambda
 !JE20141205>>
 
@@ -1228,8 +1228,8 @@
              IF(.FALSE.) THEN
 !                  nat=int(sol(i,n))
-!                    print *,i,n
+!                    PRINT *,i,n
                     IF(sol(i,n)>1..and.sol(i,n)<15.) nat=int(sol(i,n))
 !JE20140526<<
-!                    print *,'JE: WARNING: nat=0 forced to nat=99!! and doing nothing'
+!                    PRINT *,'JE: WARNING: nat=0 forced to nat=99!! and doing nothing'
                    IF(sol(i,n)<0.5) THEN
                       nat=99
@@ -1317,5 +1317,5 @@
         flux2=flux2+ft2*cpcent*cerod
         flux3=flux3+ft3*cpcent*cerod
-!       print *,'JEflux :',kwb,n,flux1,flux2,flux3
+!       PRINT *,'JEflux :',kwb,n,flux1,flux2,flux3
 80 CONTINUE
              ENDDO !n=1,ntyp
@@ -1348,14 +1348,14 @@
 
 
-!print *,' JE fluxdust in calcdust'
+!PRINT *,' JE fluxdust in calcdust'
 ! DO k=1,klon
 !   DO i=1,ndistb
-!!print *,k,i,fluxdust(k,i)
+!!PRINT *,k,i,fluxdust(k,i)
 !enddo
 !enddo
-!print *,' JE emisbin in calcdust'
+!PRINT *,' JE emisbin in calcdust'
 !do k=1,klon
 !do j=1,nbins
-!!print *,k,j,emisbin(k,j)
+!!PRINT *,k,j,emisbin(k,j)
 !enddo
 !enddo 
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/finemission.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/finemission.f90	(revision 5159)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/finemission.f90	(revision 5160)
@@ -14,13 +14,15 @@
   USE indice_sol_mod
   USE infotrac
-  ! USE phytracr_spl_mod, ONLY: nbreg_dust, nbreg_ind, nbreg_bb
+  ! USE lmdz_phytracr_spl, ONLY: nbreg_dust, nbreg_ind, nbreg_bb
   USE lmdz_yomcst
 
 USE lmdz_dimensions, ONLY: iim, jjm, llm, ndm
   USE lmdz_paramet
+USE lmdz_chem, ONLY: idms, iso2, iso4, ih2s, idmso, imsa, ih2o2, &
+          n_avogadro, masse_s, masse_so4, rho_water, rho_ice
   IMPLICIT NONE
 
 
-  INCLUDE "chem.h"
+
 
 
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/gastoparticle.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/gastoparticle.f90	(revision 5159)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/gastoparticle.f90	(revision 5160)
@@ -1,19 +1,14 @@
 SUBROUTINE gastoparticle(pdtphys, zdz, zrho, xlat, pplay, t_seri, &
-        id_prec, id_fine, &
-        tr_seri, his_g2pgas, his_g2paer)
-  !nhl     .                         fluxso4chem, flux_sparam_sulf,
-
+        id_prec, id_fine, tr_seri, his_g2pgas, his_g2paer)
   USE dimphy
   USE infotrac
   USE lmdz_YOECUMF
-  ! USE indice_sol_mod
   USE lmdz_yomcst
+  USE lmdz_dimensions, ONLY: iim, jjm, llm, ndm
+  USE lmdz_chem, ONLY: idms, iso2, iso4, ih2s, idmso, imsa, ih2o2, &
+          n_avogadro, masse_s, masse_so4, rho_water, rho_ice
+  USE lmdz_chem_spla, ONLY: masse_ammsulfate
 
-USE lmdz_dimensions, ONLY: iim, jjm, llm, ndm
   IMPLICIT NONE
-  !
-
-  INCLUDE "chem.h"
-  INCLUDE "chem_spla.h"
 
   REAL :: pdtphys
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/incloud_scav.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/incloud_scav.f90	(revision 5159)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/incloud_scav.f90	(revision 5160)
@@ -12,7 +12,9 @@
 USE lmdz_dimensions, ONLY: iim, jjm, llm, ndm
   USE lmdz_paramet
+USE lmdz_chem, ONLY: idms, iso2, iso4, ih2s, idmso, imsa, ih2o2, &
+          n_avogadro, masse_s, masse_so4, rho_water, rho_ice
   IMPLICIT NONE
 
-  INCLUDE "chem.h"
+
 
 
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/incloud_scav_lsc.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/incloud_scav_lsc.f90	(revision 5159)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/incloud_scav_lsc.f90	(revision 5160)
@@ -12,8 +12,10 @@
 USE lmdz_dimensions, ONLY: iim, jjm, llm, ndm
   USE lmdz_paramet
+USE lmdz_chem, ONLY: idms, iso2, iso4, ih2s, idmso, imsa, ih2o2, &
+          n_avogadro, masse_s, masse_so4, rho_water, rho_ice
   IMPLICIT NONE
 
 
-  INCLUDE "chem.h"
+
 
 
@@ -79,9 +81,9 @@
     !nhl     .             his_dhcon1(1,it))
 
-    !  print *,'JE inscav0'
+    !  PRINT *,'JE inscav0'
     !  IF (iflag_con.LT.3) THEN
 
-    !  print *,'JE inscav1'
-    !  print *,'iflag_con',iflag_con
+    !  PRINT *,'JE inscav1'
+    !  PRINT *,'iflag_con',iflag_con
     !  CALL inscav_spl(pdtphys,it,masse(it),henry(it),kk(it),1.e-3,
     ! .             pmflxr,pmflxs,zrho,zdz,t_seri,aux_var1,aux_var3)
@@ -97,5 +99,5 @@
 
 
-    !  print *,'JE inscav2'
+    !  PRINT *,'JE inscav2'
     DO j = 1, klev
       DO i = 1, klon
@@ -111,4 +113,4 @@
   ENDDO !--boucle sur it
 
-  ! print *,'JE inscav3'
+  ! PRINT *,'JE inscav3'
 END SUBROUTINE incloud_scav_lsc
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/inscav_spl.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/inscav_spl.f90	(revision 5159)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/inscav_spl.f90	(revision 5160)
@@ -4,6 +4,8 @@
   USE lmdz_YOECUMF
   USE lmdz_yomcst
+  USE lmdz_dimensions, ONLY: iim, jjm, llm, ndm
+  USE lmdz_chem, ONLY: idms, iso2, iso4, ih2s, idmso, imsa, ih2o2, &
+          n_avogadro, masse_s, masse_so4, rho_water, rho_ice
 
-USE lmdz_dimensions, ONLY: iim, jjm, llm, ndm
   IMPLICIT NONE
   !=====================================================================
@@ -13,6 +15,4 @@
   !=====================================================================
   !
-
-  INCLUDE "chem.h"
 
   INTEGER :: it
@@ -124,5 +124,5 @@
         beta = MIN(MAX(0.0, -beta), 1.0)
       ELSE                          !--reevaporation non totale pour aerosols
-        !print *,'FRAC USED IN INSCAV_SPL'
+        !PRINT *,'FRAC USED IN INSCAV_SPL'
         beta = MIN(MAX(0.0, -beta) * frac, 1.0)
       ENDIF
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/lmdz_chem_spla.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/lmdz_chem_spla.f90	(revision 5160)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/lmdz_chem_spla.f90	(revision 5160)
@@ -0,0 +1,8 @@
+MODULE lmdz_chem_spla
+  IMPLICIT NONE; PRIVATE
+  PUBLIC ss_bins, masse_ammsulfate
+
+  INTEGER, PARAMETER :: ss_bins = 2
+  REAL, PARAMETER :: masse_ammsulfate = 132.0  !--g mol-1
+END MODULE lmdz_chem_spla
+
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/lmdz_precuremission.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/lmdz_precuremission.f90	(revision 5160)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/lmdz_precuremission.f90	(revision 5160)
@@ -0,0 +1,268 @@
+MODULE lmdz_precureemission
+  IMPLICIT NONE; PRIVATE
+  PUBLIC precuremission
+
+CONTAINS
+
+  ! Subroutine that calculates the emission of aerosols precursors
+  SUBROUTINE precuremission(ftsol, u10m_ec, v10m_ec, &
+          pctsrf, u_seri, v_seri, paprs, pplay, cdragh, &
+          cdragm, t_seri, q_seri, tsol, fracso2emis, &
+          frach2sofso2, bateau, zdz, zalt, &
+          kminbc, kmaxbc, pdtphys, scale_param_bb, &
+          scale_param_ind, iregion_ind, iregion_bb, &
+          nbreg_ind, nbreg_bb, &
+          lmt_so2ff_l, lmt_so2ff_h, lmt_so2nff, &
+          lmt_so2ba, lmt_so2bb_l, lmt_so2bb_h, &
+          lmt_so2volc_cont, lmt_altvolc_cont, &
+          lmt_so2volc_expl, lmt_altvolc_expl, &
+          lmt_dmsbio, lmt_h2sbio, lmt_dmsconc, &
+          lmt_dms, id_prec, id_fine, &
+          flux_sparam_ind, flux_sparam_bb, &
+          source_tr, flux_tr, tr_seri)
+
+    USE dimphy
+    USE indice_sol_mod
+    USE infotrac
+    USE lmdz_yomcst
+
+    USE lmdz_paramet
+    USE lmdz_chem, ONLY: masse_s
+    USE lmdz_chem_spla, ONLY: masse_ammsulfate
+    IMPLICIT NONE
+
+    !============================= INPUT ===================================
+    INTEGER :: kminbc, kmaxbc
+    REAL :: ftsol(klon, nbsrf)  ! temperature du sol par type
+    REAL :: tsol(klon)         ! temperature du sol moyenne
+    REAL :: t_seri(klon, klev)  ! temperature
+    REAL :: u_seri(klon, klev)  ! vent
+    REAL :: v_seri(klon, klev)  ! vent
+    REAL :: q_seri(klon, klev)  ! vapeur d eau kg/kg
+    REAL :: u10m_ec(klon), v10m_ec(klon)  ! vent a 10 metres
+    REAL :: pctsrf(klon, nbsrf)
+    REAL :: pdtphys  ! pas d'integration pour la physique (seconde)
+    REAL :: paprs(klon, klev + 1)  ! pression pour chaque inter-couche (en Pa)
+    REAL :: pplay(klon, klev)  ! pression pour le mileu de chaque couche (en Pa)
+    REAL :: cdragh(klon), cdragm(klon)
+    REAL :: fracso2emis        !--fraction so2 emis en so2
+    REAL :: frach2sofso2       !--fraction h2s from so2
+    REAL :: zdz(klon, klev)
+    LOGICAL :: edgar, bateau
+    INTEGER :: id_prec, id_fine
+
+    !------------------------- Scaling Parameters --------------------------
+
+    INTEGER :: nbreg_ind, nbreg_bb
+    INTEGER :: iregion_ind(klon)  !Defines regions for SO2, BC & OM
+    INTEGER :: iregion_bb(klon)  !Defines regions for SO2, BC & OM
+    REAL :: scale_param_bb(nbreg_bb)  !Scaling parameter for biomas burning
+    REAL :: scale_param_ind(nbreg_ind) !Scaling parameter for industrial emissions
+
+    !============================= OUTPUT ==================================
+
+    REAL :: source_tr(klon, nbtr)
+    REAL :: flux_tr(klon, nbtr)
+    REAL :: tr_seri(klon, klev, nbtr) ! traceur
+    REAL :: flux_sparam_ind(klon), flux_sparam_bb(klon)
+    !========================= LOCAL VARIABLES =============================
+    INTEGER :: i, k, kkk_cont(klon), kkk_expl(klon)
+    REAL :: zalt(klon, klev), zaltmid(klon, klev)
+    REAL :: zzdz
+    !------------------------- SULFUR emissions ----------------------------
+    REAL :: lmt_so2volc_cont(klon)  ! emissions so2 volcan (continuous)
+    REAL :: lmt_altvolc_cont(klon)  ! altitude  so2 volcan (continuous)
+    REAL :: lmt_so2volc_expl(klon)  ! emissions so2 volcan (explosive)
+    REAL :: lmt_altvolc_expl(klon)  ! altitude  so2 volcan (explosive)
+    REAL :: lmt_so2ff_l(klon)       ! emissions so2 fossil fuel (low)
+    REAL :: lmt_so2ff_h(klon)       ! emissions so2 fossil fuel (high)
+    REAL :: lmt_so2nff(klon)        ! emissions so2 non-fossil fuel
+    REAL :: lmt_so2bb_l(klon)       ! emissions de so2 biomass burning (low)
+    REAL :: lmt_so2bb_h(klon)       ! emissions de so2 biomass burning (high)
+    REAL :: lmt_so2ba(klon)         ! emissions de so2 bateau
+    REAL :: lmt_dms(klon)           ! emissions de dms
+    REAL :: lmt_dmsconc(klon)       ! concentration de dms oceanique
+    REAL :: lmt_dmsbio(klon)        ! emissions de dms bio
+    REAL :: lmt_h2sbio(klon)        ! emissions de h2s bio
+
+    EXTERNAL condsurfs, liss, nightingale
+    !=========================================================================
+    ! Modifications introduced by NHL
+    ! -Variables to save fluxes were introduced
+    ! -lmt_so2ba was multiplied by fracso2emis in line 117
+    ! -scale_param_bb was introduced in line 105
+    ! The last two modifications were errors existing in the original version
+    !=========================================================================
+    !=========================================================================
+    ! LOW LEVEL EMISSIONS
+    !=========================================================================
+
+    CALL nightingale(u_seri, v_seri, u10m_ec, v10m_ec, paprs, &
+            pplay, cdragh, cdragm, t_seri, q_seri, ftsol, &
+            tsol, pctsrf, lmt_dmsconc, lmt_dms)
+
+    IF (.NOT.bateau) THEN
+      DO i = 1, klon
+        lmt_so2ba(i) = 0.0
+      ENDDO
+    ENDIF
+
+    DO i = 1, klon
+      IF (iregion_ind(i)>0) THEN
+        IF(id_prec>0) source_tr(i, id_prec) = source_tr(i, id_prec) &
+                + fracso2emis &
+                        * scale_param_ind(iregion_ind(i)) * lmt_so2ff_l(i) * 1.e4 &
+                + scale_param_ind(iregion_ind(i)) * lmt_so2ff_l(i) * 1.e4 &
+                        * frach2sofso2            ! molec/m2/s
+
+        IF(id_fine>0) source_tr(i, id_fine) = &
+                source_tr(i, id_fine) + (1 - fracso2emis) &
+                        * scale_param_ind(iregion_ind(i)) * lmt_so2ff_l(i) &
+                        * 1.e4 * masse_ammsulfate / RNAVO  ! g/m2/s
+
+        IF(id_prec>0)   flux_tr(i, id_prec) = flux_tr(i, id_prec) + (&
+                scale_param_ind(iregion_ind(i)) * (lmt_so2ff_l(i) + &
+                        lmt_so2ff_h(i)) &
+                        * frach2sofso2 &
+                        + scale_param_ind(iregion_ind(i)) * (lmt_so2ff_l(i) + &
+                        lmt_so2ff_h(i)) &
+                        * fracso2emis &
+                ) * 1.e4 / RNAVO * masse_s * 1.e3          ! mgS/m2/s
+
+        IF(id_fine>0)  flux_tr(i, id_fine) = &
+                flux_tr(i, id_fine) + (1 - fracso2emis) &
+                        * scale_param_ind(iregion_ind(i)) * (lmt_so2ff_l(i) + &
+                        lmt_so2ff_h(i)) &
+                        * 1.e4 / RNAVO * masse_ammsulfate * 1.e3    ! mgS/m2/s
+
+        flux_sparam_ind(i) = flux_sparam_ind(i) + (1 - fracso2emis) &
+                * scale_param_ind(iregion_ind(i)) * (lmt_so2ff_l(i) + &
+                lmt_so2ff_h(i)) &
+                * 1.e4 / RNAVO * masse_ammsulfate * 1.e3    ! mgS/m2/s
+      ENDIF
+      IF (iregion_bb(i)>0) THEN
+        IF(id_prec>0) source_tr(i, id_prec) = &
+                source_tr(i, id_prec) + fracso2emis &
+                        * scale_param_bb(iregion_bb(i)) * lmt_so2bb_l(i) &
+                        * (1. - pctsrf(i, is_oce)) * 1.e4
+
+        IF(id_fine>0)     source_tr(i, id_fine) = &
+                source_tr(i, id_fine) + (1 - fracso2emis) &
+                        * scale_param_bb(iregion_bb(i)) * lmt_so2bb_l(i) * &
+                        (1. - pctsrf(i, is_oce)) * 1.e4 * &
+                        masse_ammsulfate / RNAVO  ! g/m2/s
+
+        IF(id_prec>0)     flux_tr(i, id_prec) = flux_tr(i, id_prec) + &
+                (scale_param_bb(iregion_bb(i)) * lmt_so2bb_l(i) &
+                        + scale_param_bb(iregion_bb(i)) * lmt_so2bb_h(i)) &
+                        * (1. - pctsrf(i, is_oce)) * fracso2emis &
+                        * 1.e4 / RNAVO * masse_s * 1.e3          ! mgS/m2/s
+
+        IF(id_fine>0) flux_tr(i, id_fine) = &
+                flux_tr(i, id_fine) + (1 - fracso2emis) &
+                        * (scale_param_bb(iregion_bb(i)) * lmt_so2bb_l(i) &
+                                + scale_param_bb(iregion_bb(i)) * lmt_so2bb_h(i)) &
+                        * (1. - pctsrf(i, is_oce)) &
+                        * 1.e4 / RNAVO * masse_ammsulfate * 1.e3    ! mgS/m2/s
+
+        flux_sparam_bb(i) = &
+                scale_param_bb(iregion_bb(i)) * (lmt_so2bb_l(i) + &
+                        lmt_so2bb_h(i)) &
+                        * (1. - pctsrf(i, is_oce)) * fracso2emis &
+                        * 1.e4 / RNAVO * masse_s * 1.e3          ! mgS/m2/s
+        flux_sparam_bb(i) = flux_sparam_bb(i) + (1 - fracso2emis) * &
+                (scale_param_bb(iregion_bb(i)) * lmt_so2bb_l(i) + &
+                        scale_param_bb(iregion_bb(i)) * lmt_so2bb_h(i)) &
+                * (1. - pctsrf(i, is_oce)) &
+                * 1.e4 / RNAVO * masse_ammsulfate * 1.e3    ! mgS/m2/s
+      ENDIF
+      IF(id_prec>0)   source_tr(i, id_prec) = source_tr(i, id_prec) &
+              + fracso2emis &
+                      * (lmt_so2ba(i) + lmt_so2nff(i)) * 1.e4 &
+              + (lmt_h2sbio(i) &
+                      + lmt_dms(i) + lmt_dmsbio(i)) * 1.e4            ! molec/m2/s
+
+      IF(id_fine>0)   source_tr(i, id_fine) = source_tr(i, id_fine) &
+              + (1 - fracso2emis) &
+                      * (lmt_so2ba(i) + lmt_so2nff(i)) * 1.e4 * &
+                      masse_ammsulfate / RNAVO  ! g/m2/s
+
+      IF(id_prec>0)   flux_tr(i, id_prec) = flux_tr(i, id_prec) &
+              + (lmt_h2sbio(i) &
+                      + lmt_so2volc_cont(i) + lmt_so2volc_expl(i) &
+                      + (lmt_so2ba(i) + lmt_so2nff(i)) * fracso2emis &
+                      + lmt_dms(i) + lmt_dmsbio(i)) &
+                      * 1.e4 / RNAVO * masse_s * 1.e3          ! mgS/m2/s
+
+      IF(id_fine>0)   flux_tr(i, id_fine) = flux_tr(i, id_fine) &
+              + (1 - fracso2emis) &
+                      * (lmt_so2ba(i) + lmt_so2nff(i)) &
+                      * 1.e4 / RNAVO * masse_ammsulfate * 1.e3    ! mgS/m2/s
+
+      flux_sparam_ind(i) = flux_sparam_ind(i) + (1 - fracso2emis) &
+              * lmt_so2nff(i) &
+              * 1.e4 / RNAVO * masse_ammsulfate * 1.e3    ! mgS/m2/s
+
+    ENDDO
+
+    !========================================================================
+    ! HIGH LEVEL EMISSIONS
+    !========================================================================
+    !  Source de SO2 volcaniques
+    DO i = 1, klon
+      kkk_cont(i) = 1
+      kkk_expl(i) = 1
+    ENDDO
+    DO k = 1, klev - 1
+      DO i = 1, klon
+        zaltmid(i, k) = zalt(i, k) + zdz(i, k) / 2.
+        IF (zalt(i, k + 1)<lmt_altvolc_cont(i)) kkk_cont(i) = k + 1
+        IF (zalt(i, k + 1)<lmt_altvolc_expl(i)) kkk_expl(i) = k + 1
+      ENDDO
+    ENDDO
+    IF(id_prec>0) THEN
+      DO i = 1, klon
+        tr_seri(i, kkk_cont(i), id_prec) = tr_seri(i, kkk_cont(i), id_prec) + &
+                lmt_so2volc_cont(i) / zdz(i, kkk_cont(i)) / 100. * pdtphys
+        tr_seri(i, kkk_expl(i), id_prec) = tr_seri(i, kkk_expl(i), id_prec) + &
+                lmt_so2volc_expl(i) / zdz(i, kkk_expl(i)) / 100. * pdtphys
+      ENDDO
+    ENDIF
+    !  Sources hautes de SO2
+
+
+    !--only GEIA SO2 emissions has high emissions
+    !--unit: molec/cm2/s divided by layer height (in cm) multiplied by timestep
+
+    k = 2                             !introducing emissions in level 2
+    DO i = 1, klon
+
+      IF (iregion_bb(i)>0) THEN
+        IF(id_prec>0)   tr_seri(i, k, id_prec) = &
+                tr_seri(i, k, id_prec) + fracso2emis &
+                        * scale_param_bb(iregion_bb(i)) * lmt_so2bb_h(i) &
+                        / zdz(i, k) / 100. * pdtphys
+
+        IF(id_fine>0)     tr_seri(i, k, id_fine) = tr_seri(i, k, id_fine) &
+                + (1. - fracso2emis) &
+                        * scale_param_bb(iregion_bb(i)) * lmt_so2bb_h(i) &
+                        * masse_ammsulfate / RNAVO / zdz(i, k) / 100. * pdtphys   !g/cm3
+      ENDIF
+      IF (iregion_ind(i)>0) THEN
+        IF(id_prec>0)  tr_seri(i, k, id_prec) = &
+                tr_seri(i, k, id_prec) + (fracso2emis &
+                        * scale_param_ind(iregion_ind(i)) * lmt_so2ff_h(i) &
+                        + frach2sofso2 &
+                                * scale_param_ind(iregion_ind(i)) * lmt_so2ff_h(i)) &
+                        / zdz(i, k) / 100. * pdtphys
+
+        IF(id_fine>0)    tr_seri(i, k, id_fine) = tr_seri(i, k, id_fine) &
+                + (1. - fracso2emis) &
+                        * scale_param_ind(iregion_ind(i)) * lmt_so2ff_h(i) &
+                        * masse_ammsulfate / RNAVO / zdz(i, k) / 100. * pdtphys   !g/cm3
+      ENDIF
+
+    ENDDO
+
+  END SUBROUTINE precuremission
+END MODULE lmdz_precureemission
